# Couenne::CouenneBranchingObject Class Reference

"Spatial" branching object. More...

`#include <CouenneBranchingObject.hpp>`

Inheritance diagram for Couenne::CouenneBranchingObject:

List of all members.

## Public Member Functions
| CouenneBranchingObject (OsiSolverInterface *solver, const OsiObject *originalObject, JnlstPtr jnlst, CouenneCutGenerator *c, CouenneProblem *p, expression *var, int way, CouNumber brpoint, bool doFBBT, bool doConvCuts)
| Constructor.
| CouenneBranchingObject (const CouenneBranchingObject &src)
| Copy constructor.
virtual OsiBranchingObject * | clone () const
| cloning method
virtual double | branch (OsiSolverInterface *solver=NULL)
| Execute the actions required to branch, as specified by the current state of the branching object, and advance the object's state.
virtual bool | boundBranch () const
| does this branching object only change variable bounds?
void | setSimulate (bool s)
| set simulate_ field below
expression * | variable ()
| return branching variable
void | branchCore (OsiSolverInterface *, int, int, bool, double, t_chg_bounds *&)
| Perform branching step.
## Static Public Attributes
static int | nOrbBr
static int | maxDepthOrbBranch
static int | nSGcomputations
## Protected Attributes
CouenneCutGenerator * | cutGen_
| Pointer to CouenneCutGenerator (if any); if not NULL, allows to do extra cut generation during branching.
CouenneProblem * | problem_
| Pointer to CouenneProblem (necessary to allow FBBT).
expression * | variable_
| The index of the variable this branching object refers to.
JnlstPtr | jnlst_
| SmartPointer to the Journalist.
bool | doFBBT_
| shall we do Feasibility based Bound Tightening (FBBT) at branching?
bool | doConvCuts_
| shall we add convexification cuts at branching?
double | downEstimate_
| down branch estimate (done at selectBranch with reduced costs)
double | upEstimate_
| up branch estimate
bool | simulate_
| are we currently in strong branching?

## Detailed Description

"Spatial" branching object.

Branching can also be performed on continuous variables.

Definition at line 37 of file CouenneBranchingObject.hpp.

## Constructor & Destructor Documentation

Couenne::CouenneBranchingObject::CouenneBranchingObject | ( | OsiSolverInterface * | solver,
|  | const OsiObject * | originalObject,
|  | JnlstPtr | jnlst,
|  | CouenneCutGenerator * | c,
|  | CouenneProblem * | p,
|  | expression * | var,
|  | int | way,
|  | CouNumber | brpoint,
|  | bool | doFBBT,
|  | bool | doConvCuts |
| ) |  |  |

Constructor.

Referenced by clone().

Couenne::CouenneBranchingObject::CouenneBranchingObject | ( | const CouenneBranchingObject & | src | ) | `[inline]`

Copy constructor.

Definition at line 54 of file CouenneBranchingObject.hpp.

## Member Function Documentation

virtual OsiBranchingObject* Couenne::CouenneBranchingObject::clone | ( |  | ) | const`[inline, virtual]`

cloning method

Reimplemented in Couenne::CouenneComplBranchingObject, and Couenne::CouenneOrbitBranchingObj.

Definition at line 68 of file CouenneBranchingObject.hpp.

References CouenneBranchingObject().

virtual double Couenne::CouenneBranchingObject::branch | ( | OsiSolverInterface * | solver = `NULL` | ) | `[virtual]`

Execute the actions required to branch, as specified by the current state of the branching object, and advance the object's state.

Returns change in guessed objective on next branch

Reimplemented in Couenne::CouenneComplBranchingObject, and Couenne::CouenneOrbitBranchingObj.

virtual bool Couenne::CouenneBranchingObject::boundBranch | ( |  | ) | const`[inline, virtual]`

does this branching object only change variable bounds?

Reimplemented in Couenne::CouenneOrbitBranchingObj.

Definition at line 79 of file CouenneBranchingObject.hpp.

References doConvCuts_.

void Couenne::CouenneBranchingObject::setSimulate | ( | bool | s | ) | `[inline]`

set simulate_ field below

Reimplemented in Couenne::CouenneOrbitBranchingObj.

Definition at line 83 of file CouenneBranchingObject.hpp.

References simulate_.

expression* Couenne::CouenneBranchingObject::variable | ( |  | ) | `[inline]`

return branching variable

Definition at line 87 of file CouenneBranchingObject.hpp.

References variable_.

void Couenne::CouenneBranchingObject::branchCore | ( | OsiSolverInterface * | ,
|  | int | ,
|  | int | ,
|  | bool | ,
|  | double | ,
|  | t_chg_bounds *& |  |
| ) |  |  |

Perform branching step.

## Member Data Documentation

int Couenne::CouenneBranchingObject::nOrbBr`[static]`

Definition at line 94 of file CouenneBranchingObject.hpp.

int Couenne::CouenneBranchingObject::maxDepthOrbBranch`[static]`

Definition at line 95 of file CouenneBranchingObject.hpp.

int Couenne::CouenneBranchingObject::nSGcomputations`[static]`

Definition at line 96 of file CouenneBranchingObject.hpp.

CouenneCutGenerator* Couenne::CouenneBranchingObject::cutGen_`[protected]`

Pointer to CouenneCutGenerator (if any); if not NULL, allows to do extra cut generation during branching.

Definition at line 102 of file CouenneBranchingObject.hpp.

CouenneProblem* Couenne::CouenneBranchingObject::problem_`[protected]`

Pointer to CouenneProblem (necessary to allow FBBT).

Definition at line 105 of file CouenneBranchingObject.hpp.

expression* Couenne::CouenneBranchingObject::variable_`[protected]`

The index of the variable this branching object refers to.

If the corresponding CouenneObject was created on w=f(x,y), it is either x or y, chosen previously with a call to getFixVar() expression *reference_;

Definition at line 111 of file CouenneBranchingObject.hpp.

Referenced by variable().

JnlstPtr Couenne::CouenneBranchingObject::jnlst_`[protected]`

SmartPointer to the Journalist.

Definition at line 114 of file CouenneBranchingObject.hpp.

bool Couenne::CouenneBranchingObject::doFBBT_`[protected]`

shall we do Feasibility based Bound Tightening (FBBT) at branching?

Definition at line 117 of file CouenneBranchingObject.hpp.

bool Couenne::CouenneBranchingObject::doConvCuts_`[protected]`

shall we add convexification cuts at branching?

Definition at line 120 of file CouenneBranchingObject.hpp.

Referenced by Couenne::CouenneOrbitBranchingObj::boundBranch(), and boundBranch().

double Couenne::CouenneBranchingObject::downEstimate_`[protected]`

down branch estimate (done at selectBranch with reduced costs)

Definition at line 123 of file CouenneBranchingObject.hpp.

double Couenne::CouenneBranchingObject::upEstimate_`[protected]`

up branch estimate

Definition at line 126 of file CouenneBranchingObject.hpp.

bool Couenne::CouenneBranchingObject::simulate_`[protected]`

are we currently in strong branching?

Definition at line 129 of file CouenneBranchingObject.hpp.

Referenced by Couenne::CouenneOrbitBranchingObj::setSimulate(), and setSimulate().

The documentation for this class was generated from the following file:

- CouenneBranchingObject.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines